;; [[file:arroyo-nixos.org::*Calling in to the Arcology to generate \[\[id:cce/my_nixos_configuration\]\[My NixOS Configuration\]\]][Calling in to the Arcology to generate [[id:cce/my_nixos_configuration][My NixOS Configuration]]:1]]
(defun arroyo-nixos-imports (&optional role)
  (arroyo-generate-imports "nixos" role))
;; Calling in to the Arcology to generate [[id:cce/my_nixos_configuration][My NixOS Configuration]]:1 ends here

;; [[file:arroyo-nixos.org::*Flooding the Arroyo tangles and deploys all sub-systems][Flooding the Arroyo tangles and deploys all sub-systems:1]]
(defun arroyo-nixos-full-spread (host &optional local-only switch-action)
  "Flood the arroyo. Tangle all related files and run morph deploy.
DEP-FILE is a string pointing to a Morph network definition.
SWITCH-ACTION is one of the actions which morph deploy expects. Read its docs."
  (interactive (list (->> (shell-command-to-string "deploy-targets")
                          (s-split "\n")
                          (append '("--all"))
                          (completing-read "Which host do you want to deploy to? "))))
  (let ((switch-action (or switch-action "switch")))
    ;; expand this to include CCE_NIXOS keywords eventually
    (org-babel-tangle-file (expand-file-name "cce/home-manager.org" org-roam-directory))
    (org-babel-tangle-file (expand-file-name "arroyo/arroyo-emacs.org" org-roam-directory))
    (arroyo-emacs-generate-init)
    (async-shell-command (format "deploy -a %s %s" switch-action host)
                         "*nix-deploy*")))

(defalias 'arroyo-flood 'arroyo-nixos-full-spread)
;; Flooding the Arroyo tangles and deploys all sub-systems:1 ends here

;; [[file:arroyo-nixos.org::*Flooding the Arroyo tangles and deploys all sub-systems][Flooding the Arroyo tangles and deploys all sub-systems:2]]
(provide 'arroyo-nixos)
;; Flooding the Arroyo tangles and deploys all sub-systems:2 ends here
